% Figure1_6.m
% It requires the following functions:
% eulerE.m
% eulerVT.m
% fKepler.m
% fKeplerT.m
% fKeplerV.m
% phiKepler.m
% One can also use
% eulerI.m
% eulerTV.m
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initial and final time, and  Time step
global h
t0=0;  tf=100;   N=2000;  N2=N/2; t=[];
h = (tf-t0)/N;
% Initial Conditions 
e=0.2;   x0 = [1-e ; 0; 0; sqrt((1+e)/(1-e))];
q0=[x0(1); x0(2)];  p0=[x0(3); x0(4)]; 
% Energy at initial conditions
H0=((x0(3))^2+(x0(4))^2)/2-1/(sqrt((x0(1))^2+(x0(2))^2));


[t x1]=eulerE(@fKepler,t0,tf,x0,N);
[t q2 p2]=eulerVT(@fKeplerT,@fKeplerV,t0,tf,q0,p0,N);
%[t x1i]=eulerI(@fKepler,t0,tf,x0,N);
%[t q1 p1]=eulerTV(@fKeplerT,@fKeplerV,t0,tf,q0,p0,N);

x = x0';th=t0;
q0(1)=x0(1);p0(1)=x0(2);q0(2)=x0(3);p0(2)=x0(4);
for i=1:N;
   th=th+h;
   [q p]=phiKepler(q0,p0,h);
   x=[x; q p];
   q0=q;p0=p;
end

eP=sqrt((x(:,1)-x1(:,1)).^2+(x(:,2)-x1(:,2)).^2+(x(:,3)-x1(:,3)).^2+(x(:,4)-x1(:,4)).^2);
eSVT=sqrt((x(:,1)-q2(:,1)).^2+(x(:,2)-q2(:,2)).^2+(x(:,3)-p2(:,1)).^2+(x(:,4)-p2(:,2)).^2);
%ePi=sqrt((x(:,1)-x1i(:,1)).^2+(x(:,2)-x1i(:,2)).^2+(x(:,3)-x1i(:,3)).^2+(x(:,4)-x1i(:,4)).^2);
%eSTV=sqrt((x(:,1)-q1(:,1)).^2+(x(:,2)-q1(:,2)).^2+(x(:,3)-p1(:,1)).^2+(x(:,4)-p1(:,2)).^2);

errorE1 = ((x1(:,3)).^2+(x1(:,4)).^2)./2-1./(sqrt((x1(:,1)).^2+(x1(:,2)).^2)) - H0;
errorSVT = ((p2(:,1)).^2+(p2(:,2)).^2)./2-1./(sqrt((q2(:,1)).^2+(q2(:,2)).^2)) - H0;
%errorEI1 = ((x1i(:,3)).^2+(x1i(:,4)).^2)./2-1./(sqrt((x1i(:,1)).^2+(x1i(:,2)).^2)) - H0;
%errorSTV = ((p1(:,1)).^2+(p1(:,2)).^2)./2-1./(sqrt((q1(:,1)).^2+(q1(:,2)).^2)) - H0;

figure(1)
 subplot(2,2,1)
  hold on
  plot(t,errorE1(:),'--k','LineWidth',1.5)
  plot(t,errorSVT(:),'k-','LineWidth',1.5)
% plot(t,errorEI1(:),'--k','MarkerSize',8,'LineWidth',3)
% plot(t,errorSTV(:),'r-','MarkerSize',8)
  axis([-3 100 -0.01 0.015]) 
  xlabel('{\fontsize{14} t }')   
  ylabel('{\fontsize{14} H(t)-H_0}')   
  box

 subplot(2,2,2)
  hold on
  plot(log10(t),log10(abs(errorE1(:))),'--k','LineWidth',1.5)
  plot(log10(t),log10(abs(errorSVT(:))),'k-','LineWidth',1.5)
% plot(log10(t),log10(errorEI1(:)),'--k','MarkerSize',8,'LineWidth',2)
% plot(log10(t),log10(errorSTV(:)),'r-','MarkerSize',8)
% axis equal
  axis([-1 2 -4 0]) 
  xlabel('{\fontsize{14} log_{10}(t) }')   
  ylabel('{\fontsize{14} log_{10}|H(t)-H_0|}')   
  box

 subplot(2,2,3)
  hold on
  plot(t,eP,'--k','LineWidth',1.5)
  plot(t,eSVT,'-k','LineWidth',1.5)
% plot(t,ePi,'--k','MarkerSize',8,'LineWidth',2)
% plot(t,eSTV,'--k','MarkerSize',8,'LineWidth',2)
% axis equal
  axis([0 100 -0.05 1]) 
  xlabel('{\fontsize{14} t }')   
  ylabel('{\fontsize{14} err(q,p)}')   
  box

 subplot(2,2,4)
  hold on
  plot(log10(t),log10(eP),'--k','LineWidth',1.5)
  plot(log10(t),log10(eSVT),'-k','LineWidth',1.5)
% plot(log10(t),log10(ePi),'--k','MarkerSize',8,'LineWidth',2)
% plot(log10(t),log10(eSTV),'--k','MarkerSize',8,'LineWidth',2)
% axis equal
% axis([0 100 -0.05 0.1]) 
  axis([-1 2 -3 1]) 
  xlabel('{\fontsize{14} log_{10}(t) }')   
  ylabel('{\fontsize{14} log_{10}(err(q,p))}')   
  box

